std::experimental::erase(std::forward_list)(3)

NAME
std::experimental::erase(std::forward_list) - std::experimental::erase(std::forward_list)

Synopsis
   Defined in header <experimental/forward_list>
   template <class T, class A, class U>
   void erase(std::forward_list<T, A>& c, const U& (library fundamentals TS v2)
   value);
   Erases all elements that compare equal to value from the container. Equivalent to
   c.remove_if([&](auto& elem) { return elem == value; });

Parameters
   c - container from which to erase
   value - value to be removed

Complexity
   Linear.

Example
// Run this code
 #include <experimental/forward_list>
 #include <iostream>
 auto show = [](const auto& container) {
     for (auto e : container) {
         std::cout << e;
     }
     std::cout << '\n';
 };
 int main()
 {
     std::forward_list<int> data{1,1,1,4,1,1,1,2,1,1,1};
     show(data);
     std::experimental::erase(data, 1);
     show(data);
 }

Output:
 11141112111
 42

Notes
   Unlike std::forward_list::remove, this function template accepts heterogenous types
   and does not force a conversion to the container's value type before invoking the ==
   operator.

See also
   remove removes elements satisfying specific criteria
   remove_if (function template)
   remove removes elements satisfying specific criteria
   remove_if (public member function of
   (C++11) std::forward_list<T,Allocator>)
   erase_if (std::forward_list) Erases all elements satisfying a predicate from a
   (library fundamentals 2 TS) std::forward_list
                        (function template)